#!/usr/bin/python
# -*- coding: utf-8 -*-
'''
'''

import os, traceback, sys
from subprocess import Popen, PIPE
from signal import SIGTERM
from time import sleep

#for manipulation with clipboard

from dogtail.tree import root, SearchError
from dogtail.procedural import *
from dogtail.utils import run as appRun
from dogtail.predicate import GenericPredicate
from dogtail.rawinput import typeText

class Sysmon ():
    ''''''
    def __init__(self):
        self.appname = 'gnome-system-monitor'
        self.app = None

    def open(self, params=""):
        '''
        '''
        if len(params) > 0:
            params = " " + params
        self.__PID = appRun(self.appname + params, timeout = 10)
        sleep(5)
        try:
            self.app = root.application(self.appname)
            print "PASS Opening g-s-m"
            sleep(1)
        except SearchError:
            print "--- Failed opening g-s-m ---\nExiting."
            sys.exit(1)

    def close(self, check=True):
        '''
        '''
        ret = True
        if self.clickMenu((('Monitor','menu'), ('Quit', 'menu item'))) is False:
            print "--- FAILED failed closing using menu ---\nKilling..."
            self.kill(force=True)
            ret = False
        if check:
            sleep(10)
            try:
                root.application('gnome-system-monitor')
            except SearchError:
                print "PASS -- Did not find gsm, that is expected! --"
                return ret
            print "CLOSE: Complete FAIL: Found g-s-m after kill -9"
            return False
        return ret

    def openPreferences(self): # might raise SearchError
        ret = True
        if self.clickMenu([('Edit','menu'), ('Preferences', 'menu item')]) is False:
            print "--- FAILED Opening preferences, exiting test"
            self.kill(force=True)
            sys.exit(1)
        dialog = self.app.child(name='System Monitor Preferences', roleName='dialog')
        proc_tab = dialog.child(name='Processes', roleName='page tab')
        res_tab = dialog.child(name='Resources', roleName='page tab')
        fs_tab = dialog.child(name='File Systems', roleName='page tab')
        return {'dialog': dialog, 'proc': proc_tab, 'res' : res_tab, 'fs' : fs_tab}


    def kill(self, force = False):
        '''
        Quits running instance of gnome terminal. If force true, it kills all
        instances.
        '''
        if not force:
            os.kill(self.__PID, SIGTERM)
        else:
            Popen("kill -9 %s" % self.__PID, shell = True)

    def clickMenu(self, menuItemsList):
        '''
        Node object hotfix version, previous has been failing in beaker with some test
        @param menuItemsList here expected as a list(tuple) of tuples containing name
        and roleName respectively. When using only one of those, set the other as
        None not '' (!)

        Be careful using this when multiple g-t windows are to be opened
        '''
        for (nm, rlnm) in menuItemsList:
            try:
                item = self.app.child(roleName=rlnm, name=nm)
                item.doAction('click')
                sleep(0.2)
            except SearchError:
                return False
        return True

def openApp(app):
    pid = appRun(app, timeout = 10)
    try:
        root.application(app)
    except SearchError:
        print "--- Failed opening g-s-m ---\nExiting."
        sys.exit(1)
    sleep(5)
    return pid

def typeIntoTerminal(type_str):
    '''
    Types a text into the gnome-terminal. If you have problems with some
    characters, try to use L{putIntoterminal()} intead.
    @param type_str: String to be typed out.
    @type type_str: String
    '''
    focus.application('gnome-terminal')
    focus.widget(name="Terminal", roleName="terminal")
    typeText(type_str)

def printException():
    print "-- FAIL due to exception:"
    print '-'*60
    traceback.print_exc(file=sys.stdout)
    print '-'*60
