#!/usr/bin/env python
# https://tcms.engineering.redhat.com/case/101461/?from_plan=4222

import sys
import os
from dogtail.tree import *
import time
from sysmon_utils import *

def clickGsmProcess(sysmon, name=None):
    table_cell = sysmon.app.child(name=name, roleName='table cell')
    table_cell.click()

def main():
    ret_code = 0
    try:
        sysmon = Sysmon()
        sysmon.open()
        prefs = sysmon.openPreferences()
        prefs['proc'].click()
        prefs['res'].click()
        prefs['fs'].click()
        # a random check; will throw SearchError if pref not loaded right.
        prefs['fs'].child(roleName='spin button')
        sysmon.close(check=False)

    except Exception:
        printException() # FAIL
        ret_code = 1

    if ret_code is not 0:
        sysmon.kill(force=True)
    else:
        print '------ PASS ------'
    return ret_code
if __name__ == "__main__": sys.exit(main())
