#!/usr/bin/env python
# https://tcms.engineering.redhat.com/case/101461/?from_plan=4222

import sys
import os
from dogtail.tree import *
from dogtail.procedural import *
import time
from sysmon_utils import *

def clickGsmProcess(sysmon, name=None):
    table_cell = sysmon.app.child(name=name, roleName='table cell')
    table_cell.click()

def main():
    ret_code = 1
    try:
        sysmon = Sysmon()
        sysmon.open()
        sysmon.app.child(name='Processes', roleName='page tab').click()

        id_h = sysmon.app.child(name='ID', roleName='table column header')
        id_h.click()

        #have to click there somewhere already due to a bug #723448
        clickGsmProcess(sysmon)
        sysmon.clickMenu((('View','menu'), ('Active Processes', 'check menu item')))
        keyCombo('<Esc>')
        sleep(10) # for list to reload
        clickGsmProcess(sysmon, 'gnome-system-monitor')
        sysmon.clickMenu((('Edit','menu'), ('Kill Process', 'menu item')))

        #sleep(5)
        alert = sysmon.app.child(name='Warning', roleName='alert')
        alert.child(name='Kill Process', roleName='push button').click()
        #sleep(10)

    except Exception:
        printException() # FAIL

    try:
        root.application('gnome-system-monitor')
    except SearchError:
        print "PASS -- Did not find gsm, that is expected! --"
        ret_code = 0

    if ret_code is 1:
        print "FAIL -- GSM still running --"
        sysmon.kill(force=True)
    return ret_code
if __name__ == "__main__": sys.exit(main())
